
typedef struct NOIDEA_vector
{
	int X;
	int Y;
}	NOIDEA_vector;

int NOIDEA_mush (int noidea_in)
{
	return ((noidea_in | 1)*((noidea_in+1)>>1));
}

int NOIDEA_sin (int noidea_in, int noidea_max)
{
	int noidea_ref = noidea_max >> 2;				//360 / 4 = 90
	int noidea_quad = (noidea_in % noidea_max) / noidea_ref;	//quadran 00 01 10 11
	int noidea_quart = ((noidea_ref | 1)*((noidea_ref+1)>>1));	//mush(90);
	noidea_in %= noidea_ref;

	int noidea_tmp = ~(0 - (noidea_quad & 1));		//if ((noidea_quad & 1)==0)
	int noidea_odd = noidea_tmp & noidea_in;		//{
	noidea_in ^= noidea_odd;				//noidea_in = noidea_ref - noidea_in;
	noidea_in |= (noidea_tmp & noidea_ref) - noidea_odd;	//}

	int noidea_sinus = ((noidea_quart - ((noidea_in | 1)*((noidea_in+1)>>1))) * 1000) / noidea_quart;

	noidea_odd = (0 - ((noidea_quad & 2) >> 1)) & noidea_sinus;			
	noidea_sinus ^= noidea_odd;				//if ((noidea_quad & 2) != 0)
	noidea_sinus |= ~(noidea_odd-1);			//{	noidea_sinus = -noidea_sinus;	}

	return noidea_sinus;
}

int NOIDEA_cos (int noidea_in, int noidea_max)
{
	int noidea_ref = noidea_max >> 2;
	int noidea_quad = (noidea_in % noidea_max) / noidea_ref;
	int noidea_quart = ((noidea_ref | 1)*((noidea_ref+1)>>1));
	noidea_in %= noidea_ref;

	int noidea_tmp = 0 - (noidea_quad & 1);			//if ((noidea_quad & 1)!=0)
	int noidea_odd = noidea_tmp & noidea_in;		//{
	noidea_in ^= noidea_odd;				//noidea_in = noidea_ref - noidea_in;
	noidea_in |= (noidea_tmp & noidea_ref) - noidea_odd;	//}

	int noidea_cosinus = (1000*(noidea_quart - ((noidea_in | 1)*((noidea_in+1)>>1))))/noidea_quart;

	noidea_odd = (0-((noidea_quad & 1)^((noidea_quad & 2)>>1))) & noidea_cosinus;
	noidea_cosinus ^= noidea_odd;				//if (((noidea_quad & 1)^((noidea_quad & 2)>>1)) != 0)
	noidea_cosinus |= ~(noidea_odd-1);			//{	noidea_cosinus = -noidea_cosinus;	}

	return noidea_cosinus;
}

int NOIDEA_hype (int noidea_A, int noidea_B)
{
	int noidea_max = (((noidea_A + noidea_B) | 1)*(((noidea_A + noidea_B)+1)>>1));
	int noidea_swap = (0-((noidea_A - noidea_B)>>(sizeof(int))));
		noidea_A ^= noidea_B & noidea_swap;
		noidea_B ^= noidea_A & noidea_swap;
		noidea_A ^= noidea_B & noidea_swap;
	return (noidea_max * noidea_B) / (noidea_max - (((noidea_A) | 1)*(((noidea_A)+1)>>1)));
}

//............................................................................................


